<template>
  <q-page class="flex column">
    <!-- Toolbar -->
    <q-toolbar class="bg-background-primary">
      <div class="q-gutter-x-md">
        <q-btn label="Compile" color="secondary" @click="compileArtifact" />
        <q-btn icon="delete" color="negative" @click="deleteContract" />
      </div>

      <q-space />

      <div class="q-gutter-x-md">
        <q-toggle
          v-model="state.showArtifact"
          label="Show Artifact"
        />
        <q-btn label="Help" color="accent" @click="app.showHelp(DocsContract)" />
      </div>
    </q-toolbar>

    <q-toolbar v-if="activeContract.error" class="bg-negative">
      {{ activeContract.error }}
    </q-toolbar>

    <div class="flex row col-grow">
      <!-- Editor -->
      <div class="col">
        <div class="monaco-container">
          <vue-monaco-editor
            v-model:value="activeContract.source"
            theme="vs-dark"
            :options="MONACO_EDITOR_OPTIONS"
            language="sol"
            className="monaco"
          />
        </div>
      </div>

      <!-- Artifact -->
      <div v-if="state.showArtifact" class="col">
        <div class="monaco-container">
          <vue-monaco-editor
            :value="artifactJson"
            theme="vs-dark"
            :options="MONACO_EDITOR_READONLY_OPTIONS"
            language="json"
            className="monaco"
          />
        </div>
      </div>
    </div>
  </q-page>
</template>

<script setup lang="ts">
import { computed, ref } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import { useQuasar } from 'quasar';

import { app } from '../boot/app.js';

import DocsContract from '../docs/contract.html?raw';

const $q = useQuasar();
const $route = useRoute();
const $router = useRouter();

//-----------------------------------------------------------------------------
// State
//-----------------------------------------------------------------------------

const ACTIVE_CONTRACT = Number($route.params['i']);

const MONACO_EDITOR_OPTIONS = {
  automaticLayout: true,
  formatOnType: true,
  formatOnPaste: true,
  language: 'javascript'
}

const MONACO_EDITOR_READONLY_OPTIONS = {
  ...MONACO_EDITOR_OPTIONS,
  readOnly: true,
}

const state = ref<{
  showArtifact: boolean,
}>({
  showArtifact: false,
});

const activeContract = computed(() => app.project.value.contracts[ACTIVE_CONTRACT]);

const artifactJson = computed({
  get: () => {
    try {
      return JSON.stringify(app.project.value.contracts[ACTIVE_CONTRACT].artifact, null, 2);
    } catch (error) {
      return '';
    }
  },
  set: (_value) => {
    console.warn('Ignore');
  }
})

//-----------------------------------------------------------------------------
// Methods
//-----------------------------------------------------------------------------

function deleteContract() {
  $q.dialog({
    title: 'Confirm',
    message: 'Are you sure you want to delete this contract?',
    cancel: true,
    persistent: true
  }).onOk(() => {
    app.project.value.contracts.splice(ACTIVE_CONTRACT, 1);

    $router.push('/');
  })
}

function compileArtifact() {
  try {
    app.compileContract(activeContract.value);
    state.value.showArtifact = true;

    $q.notify({
      color: 'positive',
      message: 'Script compiled successfully',
    })
  } catch(error: any) {
    state.value.showArtifact = false;
  }
}

//-----------------------------------------------------------------------------
// Initialization/Lifecycle
//-----------------------------------------------------------------------------

if(!activeContract.value) {
  throw new Error('No contract at this index');
}

if(app.project.value.contracts[ACTIVE_CONTRACT].artifact) {
  state.value.showArtifact = true;
}

</script>
